#include "arm9.h"

enum {
	MENUALARM_0,
	MENUALARM_ALARM_HOUR,
	MENUALARM_ALARM_MIN,
	MENUALARM_SAVE,
	MENUALARM_RETURN,
} MENUALARM_SELECTED;

char *text_alarm[] = {
	"== ALARM CLOCK SETTINGS ==",
	"ALARM CLOCK HOUR: --/--         ",
  "ALARM CLOCK MINUTE: --/--/----  ",
  "RETURN AND SAVE",
  "RETURN WITHOUT SAVING"};
#define OPTS_alarm (sizeof(text_alarm)/sizeof(char*))
  
void menu_alarm() {
	u32 i,selected,j;
	u32 k;
	
	i=PersonalData->alarmHour;
	sprintf(text_alarm[MENUALARM_ALARM_HOUR],"ALARM CLOCK HOUR: %.2X/%.2d/%.2d%cM",i,i,
																								(i<13)?( (i==0)?12:i ):(i-12),(i<12)?'A':'P');
	
	i=PersonalData->alarmMinute;
	sprintf(text_alarm[MENUALARM_ALARM_MIN],"ALARM CLOCK MINUTE: %.2X/%.2d",i,i);


	selected=0;
	while(1) {
		swiWaitForVBlank();
		
		for(i=0;i<OPTS_alarm;i++)
			option3(text_alarm,i,i==selected);

		k=keysDown();
		if(IPC_XKEYS & 0x80)	//lid closed
			arm9sleep();
		if(k&KEY_UP)
			selected--;
		if(k&KEY_DOWN)
			selected++;
		if(k&KEY_START)
			return;
		selected%=OPTS_alarm;
		if(selected==0 && (k&KEY_UP)) selected=OPTS_alarm-1;
		if(selected==0 && !(k&KEY_UP)) selected=1;
		if((k&KEY_LEFT) || (k&KEY_RIGHT) || (k&KEY_A) || (k&KEY_B)) {
			switch(selected) {

				case MENUALARM_ALARM_HOUR:  //Alarm clock hour
					i=PersonalData->alarmHour;
					if(k&KEY_LEFT) i=(i+23)%24;
					if(k&KEY_RIGHT) i=(i+1)%24;
					if((k&KEY_A) && (i < 12)) i=(i+12)%24;
					if((k&KEY_B) && (i >= 12)) i=(i-12)%24;
					sprintf(text_alarm[MENUALARM_ALARM_HOUR],"ALARM CLOCK HOUR: %.2X/%.2d/%.2d%cM",i,i,
																								(i<13)?( (i==0)?12:i ):(i-12),(i<12)?'A':'P');
					PersonalData->alarmHour=i;
					break;
					
				case MENUALARM_ALARM_MIN:
					i=PersonalData->alarmMinute;
					if(k&KEY_LEFT) i=(i+59)%60;
					if(k&KEY_RIGHT) i=(i+1)%60;
					if(k&KEY_A) i=(i+10)%60;
					if(k&KEY_B) i=(i+50)%60;
					sprintf(text_alarm[MENUALARM_ALARM_MIN],"ALARM CLOCK MINUTE: %.2X/%.2d",i,i);
					PersonalData->alarmMinute=i;
					break;
			}
		}
		if(k&KEY_SELECT) {
			if(selected==MENUALARM_SAVE)
			{
				IPC_ARM9=IPC_WRITE_PSETTINGS;
				break;
			}
			if(selected==MENUALARM_RETURN)
				break;
		}
	}
}
 

void alarmclock() {
	char i,j,v,w,s,lid;
	u16 *p;
	u32 k;
	s=99;
	lid=1;
	char alarm=0;
	char snooze=0;
	char alarmhour=PersonalData->alarmHour,alarmmin=PersonalData->alarmMinute;
	while(1) {
		swiWaitForVBlank();

		if(s!=IPC->curtime[7]) {
			s=IPC->curtime[7];
	
			for(i=3;i<12;i++) {
				p=(u16*)(SCREEN_BASE_BLOCK_SUB(0)+i*64+5);
				for(j=0;j<25;j++) {
					if(j<25) v=(IPC->curtime[6])%10;
					if(j<20) v=(IPC->curtime[6])/10;
					if(j<15) v=11;
					if(j<10) v=(IPC->curtime[5])%10;
					if(j<5) v=(IPC->curtime[5])/10;
					w=0;
					if(j%5==1) {
						if(i<7 && (v==0 || v>3) && v!=7) w=1;
						if(i>7 && v%2==0 && v!=4) w=1;
					}
					if(j%5==4) {
						if(i<7 && v!=5 && v!=6) w=1;
						if(i>7 && v!=2) w=1;
					}
					if(j%5==2 || j%5==3 || (j%5>0 && i==7)) {
						if(i==3 && v!=1 && v!=4) w=1;
						if(i==7 && v>1 && v!=7) w=1;
						if(i==11 && v%3!=1) w=1;
					}
					if(v==11) {
						w=0;
						v=(IPC->curtime[7])&1;
						if(i%4==1 && v==0 && j==12) w=1;
					}
					*p++=0x107f*w;
				}
			}
	
			if(alarmhour==IPC->curtime[5] && alarmmin==IPC->curtime[6] && alarm==0) {
				p=(u16*)(SCREEN_BASE_BLOCK_SUB(0)+2);
				*p='!';
				IPC_ARM9=IPC_ALARM;
				alarm=1;
				snooze=0;
			}
			if(alarmmin!=IPC->curtime[6] && alarm==2)
				alarm=0;
		}

		k=keysDown();
		display_info();
		if(IPC_XKEYS & 0x80) {	//lid closed
			if(lid) {
				lid=0;
				IPC_ARM9=IPC_LIDCLOSE;
			}
		}
		else {
			if(!lid) {
				lid=1;
				IPC_ARM9=IPC_LIDOPEN;
			}
		}
		if(k&KEY_L)
			IPC_ARM9=IPC_SET_TOP_LIGHT;
		if(k&KEY_R)
			IPC_ARM9=IPC_SET_BOTTOM_LIGHT;
		if(k&KEY_Y) {
			p=(u16*)(SCREEN_BASE_BLOCK_SUB(0)+2);
			*p='!';
			IPC_ARM9=IPC_ALARM;
			alarm=1;
			snooze=0;
		}
		if(k&KEY_X) {
			p=(u16*)(SCREEN_BASE_BLOCK_SUB(0)+2);
			*p='.';
			IPC_ARM9=IPC_ALARMOFF;
			alarm=2;
			snooze=0;
			alarmhour=PersonalData->alarmHour;
			alarmmin=PersonalData->alarmMinute;
		}
		if((k&KEY_B)&&((alarm==1) || (snooze>0))) { //Snooze (Unlike most alarm clocks, this Snooze function gives you 10 minutes, not 9.
														 //Also, pushing B multiple times allows you to add 10 minutes to the snooze time.
														 //Up to 90 minutes of snooze time.
			if(snooze==0) {
				alarmhour = IPC->curtime[5];
				alarmmin = IPC->curtime[6];
			}
			alarm=0;
			if(snooze<SNOOZE_MAX_COUNT) {
				if(alarmmin >= (60 - SNOOZE_MINUTES)) {
					alarmmin -= (60 - SNOOZE_MINUTES);
					alarmhour++;
					if(alarmhour==24)
						alarmhour=0;
				}
				else
					alarmmin += SNOOZE_MINUTES;
				snooze++;
			}
			p=(u16*)(SCREEN_BASE_BLOCK_SUB(0)+2);
			*p=('0' + snooze);
			IPC_ARM9=IPC_ALARMOFF;
		}
		if(k&KEY_A) {
			p=(u16*)(SCREEN_BASE_BLOCK_SUB(0)+2);
			*p='.';
			IPC_ARM9=IPC_ALARMOFF;
			alarm=2;
			snooze=0;
			clear_screen();
			menu_alarm();
			clear_screen();
			alarmhour=PersonalData->alarmHour;
			alarmmin=PersonalData->alarmMinute;
		}
		if(k&KEY_START) {
			IPC_ARM9=IPC_ALARMOFF;
			return;
		}
	}
}