#include "arm9.h"
#include "wifi.h"


static WIFISETTINGS *wfc=(WIFISETTINGS*)WIFI_SETTING;

void Set_SSID()
{
	int i;
	char ssid[33],k;
	for(i=0;i<32;i++)
		ssid[i]=0;

	printtext(0,"=== SET SSID ===");
	printtext(1,"Press Start/Enter when finished");
	printtext(2,"Press Esc to Cancel");
	while(1) {
		swiWaitForVBlank();
		printtext(3,"                                ");
		printtext2(3,ssid);
		
		if(((k=processKeyboard(&ssid[0], 33, 0))=='\n') || (keysDown() == KEY_START))
		{
			for(i=0;i<32;i++)
			{
				wfc->ssid[i]=ssid[i];
			}
			if(ssid[0]==0)
				wfc->deleted=0xFF;
			else
				wfc->deleted=0;
			break;
		}
		if((k==0x1b) || (keysDown() == KEY_B))
			break;
	}
}

void Set_WEPKEY()
{
	int i,j;
	bool valid_wepkey=false;
	char wepkey[33]="";
	char k;
	char str[33]="";
	

	printtext(0,"=== SET Wep Key ===");
	printtext(1,"Press Start/Enter when finished");
	printtext(2,"Press Esc to Cancel");
	while(1) {
		swiWaitForVBlank();
		printtext(3,"                                ");
		printtext2(3,wepkey);
		j=strlen(wepkey);
		sprintf(str,"Strlen of Wepkey is %.2d",j);
		printtext(6,str);
		
		if(((k=processKeyboard(&wepkey[0], 33, 0))=='\n') || (keysDown() == KEY_START))
		{
			
			switch(j)
			{
				case 0: //Clear the WEP Key
					wfc->WepUsed = 0;
					valid_wepkey = true;
					break;
				case 5:
				case 13:
				case 16: //Ascii wepkey
					for(i=0;i<16;i++)
						wfc->wepkey[i] = 0;
					for(i=0;i<j;i++)
						wfc->wepkey[i] = wepkey[i];
					valid_wepkey = true;
					break;
					
					
				case 10:
				case 26:
				case 32: //HEX wepkey
					valid_wepkey = true;
					for(i=0;i<j;i++)
					{
						if((wepkey[i]>='0')&&(wepkey[i]<='9'))
						{
							wepkey[i]-='0';
						}
						else if((wepkey[i]>='A')&&(wepkey[i]<='F'))
						{
							wepkey[i]-='A';
							wepkey[i]+=10;
						}
						else if((wepkey[i]>='a')&&(wepkey[i]<='f'))
						{
							wepkey[i]-='a';
							wepkey[i]+=10;
						}
						else
						{
							valid_wepkey = false;
							break;
						}
					}
					for(i=0;i<16;i++)
						wfc->wepkey[i] = 0;
					for(i=0;i<(j/2);i++)
						wfc->wepkey[i] = (wepkey[(i*2)]<<4)+(wepkey[(i*2)+1]);
					break;
			}
			if(valid_wepkey)
			{
				switch(j)
				{
					case 0:
						wfc->WepUsed = 0;
						break;
					case 5:
						wfc->WepUsed = 5;
						break;
					case 13:
						wfc->WepUsed = 6;
						break;
					case 16:
						wfc->WepUsed = 7;
						break;
					
					case 10:
						wfc->WepUsed = 1;
						break;
					case 26:
						wfc->WepUsed = 2;
						break;
					case 32:
						wfc->WepUsed = 3;
						break;
				}
				break;
			}
			else
				printtext(4,"Invalid Wep Key");
			
		}
		
		if((k==0x1b) || (keysDown() == KEY_B))
			break;
	}
}



void ip_on_menu(char * txt[], int elem1, u32 value){
  signed char i;
  char j,k;
  for(k=0;k<4;k++) {
	  j=(value>>(8*k))&0xFF;
	  for(i=2;i>=0;i--) {
	    txt[elem1][9+i+(k*4)]=(j%10)+'0';
	    j=j/10;
	  }
	}
}

enum {
	WIFIMENU_0,
	WIFIMENU_SSID,
	WIFIMENU_SSID_2,
	WIFIMENU_WEPKEY,
	WIFIMENU_WEPKEY_2,
	WIFIMENU_IP,
	WIFIMENU_GATEWAY,
	WIFIMENU_DNS1,
	WIFIMENU_DNS2,
	WIFIMENU_SUBNET,
	WIFIMENU_SAVE,
	WIFIMENU_RETURN,
} WIFIMENU_SELECTED;

char *text_wifi[]={
 "== WIFI CONFIG 0 ==",
 "SSID: ----------------",
 "      ----------------",
 "WEP KEY: ----------------",
 "         ----------------",
 "IP ADDR: ---.---.---.---",
 "GATEWAY: ---.---.---.---",
 "DNS1:    ---.---.---.---",
 "DNS2:    ---.---.---.---",
 "SUBNET:  ---.---.---.---",
 "RETURN AND SAVE",
 "RETURN WITHOUT SAVING"};
#define OPTS_wifi (sizeof(text_wifi)/sizeof(char*))

void display_ssid()
{
	char *ssid1=text_wifi[WIFIMENU_SSID];
	char *ssid2=text_wifi[WIFIMENU_SSID_2];
	int i;
	char j;
	
	for(i=0;i<16;i++)
	{
		j=wfc->ssid[i];
		if(j!=0)
			ssid1[6+i]=j;
		else
			ssid1[6+i]=' ';
		j=wfc->ssid[i+16];
		if(j!=0)
			ssid2[6+i]=j;
		else
			ssid2[6+i]=' ';
	}
}

void display_wepkey()
{
	
	char *wepkey1=text_wifi[WIFIMENU_WEPKEY];
	char *wepkey2=text_wifi[WIFIMENU_WEPKEY_2];
	int i;
	u8 j,k;
	
	int wep_char=0;
	
	switch(wfc->WepUsed)
	{
		case 0:
			wep_char = 0;
			break;
		case 1:
			wep_char = 10;
			break;
		case 2:
			wep_char = 26;
			break;
		case 3:
			wep_char = 32;
			break;
		case 5:
			wep_char = 5;
			break;
		case 6:
			wep_char = 13;
			break;
		case 7:
			wep_char = 16;
			break;
	}
	
	if((wep_char==10)||(wep_char==26)||(wep_char==32))
	{
		for(i=0;i<8;i++)
		{
			
			if((wep_char==10) && (i==5))
				break;
			
			j=wfc->wepkey[i];
			k=(j>>4)&0x0F;
			if(k>9)
				wepkey1[9+(i*2)]=(k-10)+'A';
			else
				wepkey1[9+(i*2)]=k+'0';
			k=j&0x0F;
			if(k>9)
				wepkey1[10+(i*2)]=(k-10)+'A';
			else
				wepkey1[10+(i*2)]=k+'0';
				
			if(wep_char==10)
			{
				wepkey2[9+(i*2)]=' ';
				wepkey2[10+(i*2)]=' ';
				continue;
			}
				
			if((wep_char==26) && (i>4))
			{
				wepkey2[9+(i*2)]=' ';
				wepkey2[10+(i*2)]=' ';
				continue;
			}
			
			j=wfc->wepkey[i+8];
			k=(j>>4)&0x0F;
			if(k>9)
				wepkey2[9+(i*2)]=(k-10)+'A';
			else
				wepkey2[9+(i*2)]=k+'0';
			k=j&0x0F;
			if(k>9)
				wepkey2[10+(i*2)]=(k-10)+'A';
			else
				wepkey2[10+(i*2)]=k+'0';
		}
	}
	else
	{
		for(i=0;i<16;i++)
		{
			j=wfc->wepkey[i];
			wepkey1[9+i]=j;
			wepkey2[9+i]=' ';
		}
	}
}




void write_wifi(int number)
{
	switch(number)
	{
		case 0:
			IPC_ARM9 = IPC_WRITE_WIFI_0;
			break;
		case 1:
			IPC_ARM9 = IPC_WRITE_WIFI_1;
			break;
		case 2:
			IPC_ARM9 = IPC_WRITE_WIFI_2;
			break;
	}
	/*
	IPC_ARM9_P1 = number;
	IPC_ARM9 = IPC_WRITE_WIFI;
	while(IPC_ARM7 != IPC_WRITE_WIFI);
	IPC_ARM7 = -1;*/
}

bool validate_ip(u32 ip_addr) {
	u8 i=ip_addr & 0xFF;
	if((i==0)||(i==127)||(i>=224))
		return false;
	return true;
}


u32 ip_addr_edit(u32 old_value, int mode) {
	
	int i,j,k;
	char oldip[33];
	char ipaddr[33];
	
	u32 new_value;
	
	u8 ip_value[4]={0,0,0,0};
	
	
	for(i=0;i<16;i++)
		ipaddr[i]=0;
		
	sprintf(oldip,"Old IP: %d.%d.%d.%d",old_value&0xFF,(old_value>>8)&0xFF,(old_value>>16)&0xFF,(old_value>>24)&0xFF);
	printtext(5,oldip);

  switch(mode)
  {
  	case 0:
			printtext(0,"=== Edit IP Address ===");
			break;
		case 1:
			printtext(0,"=== Edit Gateway ===");
			break;
		case 2:
			printtext(0,"=== Edit Primary DNS ===");
			break;
		case 3:
			printtext(0,"=== Edit Secondary DNS ===");
			break;
	}
	
	bool ip_valid=true;
	
	printtext(1,"Press Start/Enter when finished");
	printtext(2,"Press Esc to Cancel");
	while(1) {
		swiWaitForVBlank();
		printtext(3,"                                ");
		printtext2(3,ipaddr);
		
		
		if(((k=processKeyboard(&ipaddr[0], 16, 0))=='\n') || (keysDown() == KEY_START))
		{
			for(i=0;i<4;i++)
				ip_value[i]=0;
			
			for(i=0,j=0,k=0,ip_valid=true;(i<15)&&ip_valid;i++)
			{
				if((ipaddr[i]>='0')&&(ipaddr[i]<='9'))
				{
					j*=10;
					j+=(ipaddr[i]-'0');
					ip_value[k]=j;
					if(j>255)
						ip_valid=false;
				}
				else if (ipaddr[i]=='.')
				{
					k++;
					j=0;
				}
				else if (ipaddr[i]==0)
					break;
			}
			
			if(ip_valid)
			{
				new_value = ip_value[0] + (ip_value[1] << 8) + (ip_value[2] << 16) + (ip_value[3] << 24);
				if(validate_ip(new_value) || (new_value == 0))
					return new_value;
				else
					printtext(4,"Invalid IP address");
			}
			else
				printtext(4,"Invalid IP address");
		}

		if((k==0x1b) || (keysDown() == KEY_B))
			return old_value;
	}
	
	
	return old_value;
}

u32 subnet_from_bitcount(u8 bitcount) {
	u32 subnet=0;
	int i=bitcount;
	int j=0;
	
	while(i>0)
	{
		if(i>7)
		{
			subnet += (255 << (8*j));
			i-=8;
		}
		else
		{
			subnet += ((255 - ((0x100 >> i) - 1)) << (8*j));
			i=0;
		}
		j++;
	}
	return subnet;
}

void menu_wifi(int WifiNumber) {
	u32 i,selected;
	u32 k;
	
	bool wifi_valid;
	
	wfc = (WIFISETTINGS*)(WIFI_SETTING + ((WifiNumber-1)*0x100));
	
	//read_wifi(WifiNumber-1);
	
	display_ssid();
	display_wepkey();
	
	ip_on_menu(text_wifi,WIFIMENU_IP,wfc->IP);
	ip_on_menu(text_wifi,WIFIMENU_GATEWAY,wfc->GateWay);
	ip_on_menu(text_wifi,WIFIMENU_DNS1,wfc->PrimaryDNS);
	ip_on_menu(text_wifi,WIFIMENU_DNS2,wfc->SecondaryDNS);
	ip_on_menu(text_wifi,WIFIMENU_SUBNET,subnet_from_bitcount(wfc->Subnet));
	
	

	text_wifi[WIFIMENU_0][15]=WifiNumber+'0';
	selected=0;
	while(1) {
		swiWaitForVBlank();
		
		for(i=0;i<OPTS_wifi;i++)
		{
			option3(text_wifi,i,i==selected);
			if((i==WIFIMENU_SSID) || (i==WIFIMENU_WEPKEY))  //The first two options are 2 lines each.
			{
				option3(text_wifi,i+1,i==selected);
				i++;
			}
		}	

		k=keysDown();
		if(IPC_XKEYS & 0x80)	//lid closed
			arm9sleep();
		if(k&KEY_UP)
			selected--;
		if(k&KEY_DOWN)
			selected++;
		if(k&KEY_START)
			return;
		selected%=OPTS_wifi;
		if(selected==0 && (k&KEY_UP)) selected=OPTS_wifi-1;
		if(selected==0 && !(k&KEY_UP)) selected=1;
		if((selected==WIFIMENU_SSID_2 || selected==WIFIMENU_WEPKEY_2) && (k&KEY_UP)) selected--;
		if((selected==WIFIMENU_SSID_2 || selected==WIFIMENU_WEPKEY_2) && !(k&KEY_UP)) selected++;
		if(k&KEY_SELECT) {
			switch(selected) {
				
				case WIFIMENU_SSID:   //SSID
					clear_screen();
					Set_SSID();
					display_ssid();
					clear_screen();
					break;
					
				case WIFIMENU_WEPKEY:   //WEP Key
					clear_screen();
					Set_WEPKEY();
					display_wepkey();
					clear_screen();
					break;

				case WIFIMENU_IP:		//IP Address
					clear_screen();
					wfc->IP=ip_addr_edit(wfc->IP,0);
					ip_on_menu(text_wifi,WIFIMENU_IP,wfc->IP);
					clear_screen();
					break;
					
				case WIFIMENU_GATEWAY:		//Gateway
					clear_screen();
					wfc->GateWay=ip_addr_edit(wfc->GateWay,0);
					ip_on_menu(text_wifi,WIFIMENU_GATEWAY,wfc->GateWay);
					clear_screen();
					break;
					
				case WIFIMENU_DNS1:		//DNS 1
					clear_screen();
					wfc->PrimaryDNS=ip_addr_edit(wfc->PrimaryDNS,0);
					ip_on_menu(text_wifi,WIFIMENU_DNS1,wfc->PrimaryDNS);
					clear_screen();
					break;
					
				case WIFIMENU_DNS2:		//DNS 2
					clear_screen();
					wfc->SecondaryDNS=ip_addr_edit(wfc->SecondaryDNS,0);
					ip_on_menu(text_wifi,WIFIMENU_DNS2,wfc->SecondaryDNS);
					clear_screen();
					break;

					
				case WIFIMENU_SAVE:
					wifi_valid = true;
					if(wfc->IP != 0)
					{
						if((wfc->GateWay == 0) || ((wfc->PrimaryDNS == 0) && (wfc->SecondaryDNS == 0)))
							wifi_valid = false;
					}
					else
					{
						wfc->GateWay = 0;
						wfc->Subnet = 0;
					}
					if(wifi_valid)
					{
						write_wifi(WifiNumber-1);
					}
					else
					{
						for(i=0;i<300;i++)
						{
							swiWaitForVBlank();
							if((i%60)<30)
								printtext(14,"WIFI SETTINGS INVALID");
							else
								printtext(14,"                     ");
						}
						break;
					}
				case WIFIMENU_RETURN:
					return;
					
			}
		}
		if((k&KEY_LEFT) || (k&KEY_RIGHT))
		{
			if(selected==WIFIMENU_SUBNET)	//Subnet
			{
				i=wfc->Subnet;
				if(k&KEY_RIGHT)
					if(i<32)
						i++;
				if(k&KEY_LEFT)
					if(i>0)
						i--;
				wfc->Subnet=i;
				ip_on_menu(text_wifi,WIFIMENU_SUBNET,subnet_from_bitcount(i));
			}
		}
	}
}
